


function love.load(arg)  --This function is called exactly once at the beginning of the game.
	objects = {
		require 'game',
		require 'hud',
	}


	for i = 1,#objects do 
		if objects[i].load then 
			objects[i].load(arg) 
		end
	end 
	
end

function love.draw() --Callback function used to draw on the screen every frame.

	for i=1,#objects do 
		if objects[i].draw then 
			objects[i].draw() 
		end 
	end 
end 

--OTHER CALLBACK FUNCTIONS

function love.directorydropped(path) for i=1,#objects do if objects[i].directorydropped then objects[i].directorydropped(path) end end end --Callback function triggered when a directory is dragged and dropped onto the window.
--function love.errhand(msg, layer) for i=1,#objects do if objects[i].errhand then objects[i].errhand(msg, layer) end end end --The error handler, used to display error messages.
function love.filedropped(file) for i=1,#objects do if objects[i].filedropped then objects[i].filedropped(file) end end end --Callback function triggered when a file is dragged and dropped onto the window.
function love.focus(focus) for i=1,#objects do if objects[i].focus then objects[i].focus(focus) end end end --Callback function triggered when window receives or loses focus.
function love.keypressed(key, scancode, isrepeat) for i=1,#objects do if objects[i].keypressed then objects[i].keypressed(key, scancode, isrepeat) end end end --Callback function triggered when a key is pressed.
function love.keyreleased(key, scancode) for i=1,#objects do if objects[i].keyreleased then objects[i].keyreleased(key, scancode) end end end --Callback function triggered when a keyboard key is released.
function love.lowmemory() for i=1,#objects do if objects[i].lowmemory then objects[i].lowmemory() end end end --Callback function triggered when the system is running out of memory on mobile devices.
function love.mousefocus(focus) for i=1,#objects do if objects[i].mousefocus then objects[i].mousefocus(focus) end end end --Callback function triggered when window receives or loses mouse focus.
function love.mousemoved(x, y, dx, dy, istouch) for i=1,#objects do if objects[i].mousemoved then objects[i].mousemoved(x, y, dx, dy, istouch) end end end --Callback function triggered when the mouse is moved.
function love.mousepressed(x, y, button, istouch) for i=1,#objects do if objects[i].mousepressed then objects[i].mousepressed(x, y, button, istouch) end end end --Callback function triggered when a mouse button is pressed.
function love.mousereleased(x, y, button, istouch) for i=1,#objects do if objects[i].mousereleased then objects[i].mousereleased(x, y, button, istouch) end end end --Callback function triggered when a mouse button is released.
function love.quit() for i=1,#objects do if objects[i].quit then objects[i].quit() end end end --Callback function triggered when the game is closed.
function love.resize(w, h) for i=1,#objects do if objects[i].resize then objects[i].resize(w, h) end end end --Called when the window is resized.
--function love.run() for i=1,#objects do if objects[i].run then objects[i].run() end end end --The main function, containing the main loop. A sensible default is used when left out.
function love.textedited( text, start, length) for i=1,#objects do if objects[i].textedited then objects[i].textedited( text, start, length) end end end --Called when the candidate text for an IME has changed.
function love.textinput(text) for i=1,#objects do if objects[i].textinput then objects[i].textinput(text) end end end --Called when text has been entered by the user.
function love.threaderror(thread, errorstr) for i=1,#objects do if objects[i].threaderror then objects[i].threaderror(thread, errorstr) end end end --Callback function triggered when a Thread encounters an error.
function love.touchmoved( id, x, y, dx, dy, pressure ) for i=1,#objects do if objects[i].touchmoved then objects[i].touchmoved( id, x, y, dx, dy, pressure ) end end end --Callback function triggered when a touch press moves inside the touch screen.
function love.touchpressed( id, x, y, dx, dy, pressure ) for i=1,#objects do if objects[i].touchpressed then objects[i].touchpressed( id, x, y, dx, dy, pressure ) end end end --Callback function triggered when the touch screen is touched.
function love.touchreleased(id, x, y, dx, dy, pressure ) for i=1,#objects do if objects[i].touchreleased then objects[i].touchreleased(id, x, y, dx, dy, pressure ) end end end --Callback function triggered when the touch screen stops being touched.
function love.update(dt) for i=1,#objects do if objects[i].update then objects[i].update(dt) end end end --Callback function used to update the state of the game every frame.
function love.visible(visible) for i=1,#objects do if objects[i].visible then objects[i].visible(visible) end end end --Callback function triggered when window is shown or hidden.
function love.wheelmoved(x, y) for i=1,#objects do if objects[i].wheelmoved then objects[i].wheelmoved(x, y) end end end --Callback function triggered when the mouse wheel is moved.
function love.gamepadaxis(joystick, axis, value ) for i=1,#objects do if objects[i].gamepadaxis then objects[i].gamepadaxis(joystick, axis, value ) end end end --Called when a Joystick's virtual gamepad axis is moved.
function love.gamepadpressed(joystick, button ) for i=1,#objects do if objects[i].gamepadpressed then objects[i].gamepadpressed(joystick, button ) end end end --Called when a Joystick's virtual gamepad button is pressed.
function love.gamepadreleased(joystick, button ) for i=1,#objects do if objects[i].gamepadreleased then objects[i].gamepadreleased(joystick, button ) end end end --Called when a Joystick's virtual gamepad button is released.
function love.joystickadded(joystick) for i=1,#objects do if objects[i].joystickadded then objects[i].joystickadded(joystick) end end end --Called when a Joystick is connected.
function love.joystickaxis(joystick, axis, value ) for i=1,#objects do if objects[i].joystickaxis then objects[i].joystickaxis(joystick, axis, value ) end end end --Called when a joystick axis moves.
function love.joystickhat(joystick, hat, direction ) for i=1,#objects do if objects[i].joystickhat then objects[i].joystickhat(joystick, hat, direction ) end end end --Called when a joystick hat direction changes.
function love.joystickpressed( joystick, button ) for i=1,#objects do if objects[i].joystickpressed then objects[i].joystickpressed( joystick, button ) end end end --Called when a joystick button is pressed.
function love.joystickreleased(joystick, button ) for i=1,#objects do if objects[i].joystickreleased then objects[i].joystickreleased(joystick, button ) end end end --Called when a joystick button is released.
function love.joystickremoved(joystick) for i=1,#objects do if objects[i].joystickremoved then objects[i].joystickremoved(joystick) end end end --Called when a Joystick is disconnected.
