player = {
	-- position, dimensions, movement
	x = 0, y = 0, w = 0, h = 0,
	dx = 0, dy = 0, vx = 0, vy = 0, ax = 0, ay  0,
	-- form wil determine player appearance, abilities, and extra objects the form may create (such as projectiles)
	form = {{}}, 
	currentForm = 1
	-- animation? These will be gained from a function.
}

function player.update(dt)

	for i,form in ipairs(player.form) do -- Projectiles from each form must remain active, even when they are not the current form.
		form.update(dt)
	end

end

function player.draw()
	local p = player.form[player.currentForm]
	
	-- Concern: Draw order when there are multiple forms.
	-- current approach: have the current form drawn on top.
	for i,form in ipairs(player.form) do -- Projectiles from each form must remain active, even when they are not the current form.
		form.draw(false) -- boolean says only draw projectiles
	end	
	player.form[player.currentForm].draw(true) -- boolean says only draw payer form.  if boolean == nil, draw both.
	
end




return player