local room = {}

function room.load(room)

	local w,h = love.graphics.getDimensions()
	room.w = 800
	room.h = 600
	room.x = (w - room.w)/2
	room.y = (h - room.h)/2

	room.columns = 16
	room.rows = 12
	room.grid = { size = 50 }
	for c = 1, room.columns do
		room.grid[c] = {}
		for r = 1, room.rows do
			room.grid[c][r] = {}
			room.grid[c][r].block = false -- for now, this is the only feature in the grid.  I'll make rooms more complicated later.
			room.grid[c][r].ladder = false	-- just guessing at block types.
			room.grid[c][r].water = false
			
			-- creating walls around the room
			if c == 1 or c == room.columns or r == 1 or r == room.rows then
				room.grid[c][r].block = true
			end
			
		end
	end

end

function room.draw(room)

	love.graphics.setColor(0,0,0,100)
	love.graphics.rectangle('fill',room.x,room.y,room.w,room.h)

	for c = 1, room.columns do
		for r = 1, room.rows do
			if room.grid[c][r].block == true then
				local x = room.x + (c-1)*room.grid.size
				local y = room.y + (r-1)*room.grid.size
				love.graphics.setColor(0,255,255)
				love.graphics.rectangle('line',x,y,room.grid.size,room.grid.size)
				love.graphics.setColor(100,100,100)
				love.graphics.rectangle('fill',x,y,room.grid.size,room.grid.size)
			end
		end
	end
	
end


return room