local stage = {
	w = 800,
	h = 600,
}
local s = stage
local lg = love.graphics

function s.load()
	
	local w,h = love.graphics.getDimensions()
	s.x = (w-s.w)/2
	s.y = (h-s.h)/2
	
	local d = 800/16
	s.grid={
		d = d,
		columns = s.w/d,
		rows = s.h/d,
	}
	for c = 1, s.grid.columns do
		s.grid[c]={}
		for r = 1, s.grid.rows do
			s.grid[c][r]={}
		end
	end
	
	s.grid[10][40] = nil
	
end

function s.draw()
	lg.setColor(255,255,255)
	
	lg.printf("800 x 600 stage, with 50 x 50 sized grid cells, which match up with ZX scale, where the player character is a little taller than two squares",
		20,100,200)
	
	
	lg.setColor(0,0,0)
	lg.rectangle('fill',s.x,s.y,s.w,s.h)
	lg.rectangle('line',s.x,s.y,s.w,s.h)
	
	lg.setColor(100,130,150,50)
	
	local n = 9
	local f = s.grid.d / s.h * 2 * 2.5
	for i=1,n do
		local d = (i/n)^0.5*s.h*f
		lg.rectangle('fill',s.x+d/2,s.y+d/2,s.w-d,s.h-d)
	end
	
	for c = 1, s.grid.columns do
		for r = 1, s.grid.rows do
			local style = 'line'
			if s.grid[c][r] then
			else
				style = 'fill'
			end
			local d = s.grid.d
			local x = s.x + (c-1)*d
			local y = s.y + (r-1)*d
			lg.rectangle(style,x,y,d,d)
		end
	end
	
end

return stage