local player = {

	-- controls
	controller = { 
		up		=	{	key = 'up',	isDown = false}		,
		down 	=	{	key = 'down',	isDown = false}	,
		left 	=	{	key = 'left',	isDown = false}	,
		right	=	{	key = 'right',	isDown = false}	,
		jump	=	{	key = 'up',	isDown = false}		,
		dash	=	{	key = 'kp0',	isDown = false}	,
		act		=	{	key = 'rshift',	isDown = false}	,
		menu	=	{	key = 'return',	isDown = false}	,
		},

	-- position, displacement, velocity, acceleration
	x = 100, y = 100, dx = 0, dy = 0, vx = 0, vy = 0, ax = 0, ay = 0,
	
	--limits
	xMin, xMax, yMin, yMax, dxMin, dxMax, dyMin, dyMax, vxMin, vxMax, vyMin, vyMax, axMin, axMax,
	
	-- dimensions
	w = 100, h = 100, 
	
	--direction
	direction = 'right',
	
	-- states
	is = { onGround, inAir,},
}

function player.load()
	local w, h = love.graphics.getDimensions()
	local p = player
	p.x = w/2
	p.y = h/2
	local d = 200
	p.xMin = p.x - d
	p.xMax = p.x + d
	p.yMin = p.y - d
	p.yMax = p.y + d
	
end

function player.draw()
	local lg = love.graphics
	local p = player
	
	-- PLAYER HITBOX
	lg.setColor(0,0,0) 
	lg.rectangle('fill', p.x, p.y, p.w, p.h)
	lg.setColor(255,255,255)
	lg.rectangle('line', p.x, p.y, p.w, p.h)
	lg.print('player', p.x, p.y)
	
	-- PLAYER DIRECTION
	local d = 1/2*p.w
	if p.direction == 'right' then d = d 
	elseif p.direction == 'left' then d = -d
	end
	
	local x = p.x + p.w/2
	lg.polygon('line',
		x-d, p.y,
		x+d, p.y + p.h/2,
		x-d, p.y + p.h)
	
	-- PLAYER MOVEMENT LIMITS
	if p.xMin and p.xMax and p.yMin and p.yMax then
		lg.polygon('line',p.xMin, p.yMin, p.xMax, p.yMin, p.xMax, p.yMax, p.xMin, p.yMax)
		lg.print("xMin,yMin",p.xMin, p.yMin)
		lg.print("xMax,yMax",p.xMax, p.yMax)
	end
end

function player.keypressed(k)
	if k == player.controller.up.key then 
		love.graphics.setBackgroundColor(50,50,50) 
	end
end


return player