local playerControl={}

playerControl.key={
	{name = 'up',	bind = 'up', 		isDown = false},
	{name = 'down',	bind = 'down', 		isDown = false},
	{name = 'left',	bind = 'left', 		isDown = false},
	{name = 'right',	bind = 'right', isDown = false},
	{name = 'act 1',	bind = 'd', 	isDown = false},
	{name = 'act 2',	bind = 'space', isDown = false},
	{name = 'move 1',	bind = 's', 	isDown = false},
	{name = 'move 2',	bind = 'a', 	isDown = false},
	{name = 'menu 1',	bind = 'return',isDown = false},
	{name = 'menu 2',	bind = 'w', 	isDown = false},
	{name = 'extra 1',	bind = 'e', 	isDown = false},
	{name = 'extra 2',	bind = 'f', 	isDown = false},
	-- {name = '',	bind = '', isDown = ''},
}

function playerControl.updateKeys()
	local pc = playerControl
	pc.up = 	pc.key[1]
	pc.down = 	pc.key[2]
	pc.left = 	pc.key[3]
	pc.right = 	pc.key[4]
	pc.act1 = 	pc.key[5]
	pc.act2 = 	pc.key[6]
	pc.move1 = 	pc.key[7]
	pc.move2 = 	pc.key[8]
	pc.menu1 = 	pc.key[9]
	pc.menu2 = 	pc.key[10]
	pc.extra1 = pc.key[11]
	pc.extra2 = pc.key[12]
	
end

playerControl.menu = { 
	edit = false,
	x = 1070, 
	y = 50, 
	fontSize = 20, 
	w = 170,
	-- initialize custom controls
	custom = {{},{},{}},
	
	-- initialize default controls
	default={{},{},{}}
	}
	
local k = playerControl.key
local d = playerControl.menu.default
for i = 1,#k do
	d[1][i] = k[i].bind
	d[2][i] = k[i].bind
	d[3][i] = k[i].bind
end

playerControl.menu.default[2] = {
	'w','s','a','d','right','left','space','lshift','up','down','q','e'}
playerControl.menu.default[3] = {
	'up','down','left','right','kp0','kp0','up','down','return','rshift','rctrl','/'}


function playerControl.menu.writeTitle(b)
	love.graphics.setFont(playerControl.menu.font)
	
	love.graphics.print(b.title,b.x,b.y)
	love.graphics.print(b.title,b.x+1,b.y)
end

function playerControl.load()
	playerControl.updateKeys()
	
	
	--===========================
	-- PLAYER MENU
	

		
	playerControl.menu.h = playerControl.menu.fontSize * (#playerControl.key+6)
	playerControl.menu.font = love.graphics.newFont(playerControl.menu.fontSize-7)
	
	
	local dy = playerControl.menu.fontSize
	local dx = dy
	local x = playerControl.menu.x + 10
	local y = playerControl.menu.y
	local w = playerControl.menu.w -10
	--local k = playerControl.key
	--local d = playerControl.menu.default
	
	playerControl.menu.button={
			keyBind = {title = "PLAYER CONTROLS", x = x, y = y + dy},	
			default = {title = "LOAD PRESET", x = x, y = y + dy*(#k+2)},
			saveCustom={title = "SAVE CUSTOM", x = x, y = y + dy*(#k+4)}, 
			loadCustom={title="LOAD CUSTOM", x = x, y = y + dy*(#k+5)}
		}

	
	local b = playerControl.menu.button
	local c = playerControl.menu.custom 
	local pc = playerControl

	for i = 1, #k do	-- coordinates of keybind buttons
		b.keyBind[i] = {
			title = ' '..i..'. "'..pc.key[i].bind..'" ('..pc.key[i].name..')',
			x =x,
			y = b.keyBind.y + dy*i,
			w = w,
			h = dy,
			}
	end
	
	for i = 1, #d do	-- coordinates of restore default buttons
		b.default[i] = {
			title = i,
			x = x + dx*(i-1),
			y = b.default.y+dy,
			w = dx, h = dy
		}
	end
	
	for i = 1, #c do
		local y = b.saveCustom.y
		local x = b.saveCustom.x+(i-1)*dx + 100
		b.saveCustom[i] = {title = i, y = y, 	x = x, w = dx, h = dy}
		b.loadCustom[i] = {title = i, y = y+dy, x = x, w = dx, h = dy}
	end

	

	function playerControl.menu.draw()
	
		local m = playerControl.menu
		local lgp = love.graphics.printf
		local lg = love.graphics
		local mx,my = love.mouse.getPosition()
		
		love.graphics.setFont(m.font)
		
		--[[OUTLINE
		if mx > m.x and mx < m.x + m.w and my > m.y and my < m.y + m.h then 
			lg.setColor(0,255,255)
			lg.rectangle('line',m.x,m.y,m.w,m.h) -- outline menu area
		end--]]
		
		--INSTRUCTIONS
		local instructions = "mouse over to edit"
		local align = 'left'
		love.graphics.setColor(0,255,0)
		
		
		if mx > m.x and mx < m.x + m.w and my > m.y and my < m.button.default.y then
		
		else
			m.edit = false
		end
		
		if mx > m.x and mx < m.x + m.w and my > m.y and my < m.y + m.h then
			if m.edit == false then
				instructions = 'click to edit'
				love.graphics.setColor(0,255,255)
			
			elseif m.edit == true then
				instructions = 'press key to edit'
				love.graphics.setColor(255,255,0)
				--align = 'center'
			end
		end
		
		lgp(instructions,m.x,m.y,m.w,align)
		
		--PLAYER CONTROLS
		local k = m.button.keyBind
		
		love.graphics.setColor(255,255,255)
		if playerControl.menu.edit and my < playerControl.menu.button.default.y then 
			lg.setColor(255,100,0)
		end
			m.writeTitle(k)
		
		love.graphics.setColor(255,255,255)
		
		for i, v in ipairs(k) do

			lg.setColor(255,255,255)
			if playerControl.key[i].isDown then
				--lg.rectangle('fill',v.x,v.y,v.w,v.h)
			end	
			
			if playerControl.menu.edit and mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				lg.rectangle('line',v.x,v.y,v.w,v.h)
				--[[
				if playerControl.key[i].isDown then
					lg.rectangle('fill',v.x,v.y,v.w,v.h)
				end--]]
			end
			
			lg.setColor(255,255,255)
			if playerControl.key[i].isDown then
				lg.setColor(255,200,0)
			end	

			lgp(' '..i..'.', v.x, v.y, v.w)
			lgp(playerControl.key[i].name, v.x+30, v.y, v.w)
			
			local showTemp = false
			
			for ii,d in ipairs(playerControl.menu.button.default) do -- for each default button, check if mouse is over
				if mx > d.x and mx < d.x + d.w and my > d.y and my < d.y + d.h then
					--if mouse is over, then display the default controls in the keybind column
					if love.mouse.isDown(1) then lg.setColor (0,255,0) else lg.setColor(0,200,0) end
					for iii = 1,#k do
						local k = playerControl.menu.button.keyBind[iii]
						lgp('"'..playerControl.menu.default[ii][iii]..'"', k.x, k.y, k.w-10,'right')			
					end
					showTemp = true
				end
			end
			
			for ii,c in ipairs(playerControl.menu.button.loadCustom) do -- for each load custom button, check if mouse is over
				if #playerControl.menu.custom[ii]>0 and 
					mx > c.x and mx < c.x + c.w and my > c.y and my < c.y + c.h then
					--if mouse is over, then display the default controls in the keybind column
					if love.mouse.isDown(1) then lg.setColor (0,255,0) else lg.setColor(0,200,0) end
					for iii = 1,#k do
						local k = playerControl.menu.button.keyBind[iii]
						lgp('"'..playerControl.menu.custom[ii][iii]..'"', k.x, k.y, k.w-10,'right')			
					end
					showTemp = true
				end
			end			
		
			if showTemp == false then
				lgp('"'..playerControl.key[i].bind..'"', v.x, v.y, v.w-10,'right')			
			end
		end
			
		
		
		-- RESTORE DEFAULT
		local d = m.button.default
		lg.setColor(255,255,255)
		if --playerControl.menu.edit and 
			mx > m.x and mx < m.x + m.w and
			my > playerControl.menu.button.default.y and
			my < playerControl.menu.button.saveCustom.y	then 
				lg.setColor(255,100,0)
		end		
		m.writeTitle(d)
		
		for i, v in ipairs(d) do
			
			if mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				lg.setColor(0,100,0)
				lg.rectangle('fill',v.x,v.y,v.w,v.h)
				--lgp(v.title, v.x, v.y, v.w, 'center')
			else
			
			end
				lg.setColor(255,255,255)
				lgp(v.title, v.x, v.y, v.w, 'center')
				lg.rectangle('line',v.x,v.y,v.w,v.h)
		end
		
		--SAVE CUSTOM
		if --playerControl.menu.edit and 
			mx > m.x and mx < m.x + m.w and
			my > playerControl.menu.button.saveCustom.y and
			my < playerControl.menu.button.loadCustom.y	then 
				lg.setColor(255,100,0)
		end		
		m.writeTitle(b.saveCustom)
		for i, v in ipairs(b.saveCustom) do
			if mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				--if #m.custom[i]>0 then 
					lg.setColor(0,100,0)
				--else
				--	lg.setColor(0,0,0)
				--end
				lg.rectangle('fill',v.x,v.y,v.w,v.h)
				--lgp(v.title, v.x, v.y, v.w, 'center')
			else
			
			end
				lg.setColor(255,255,255)
				lgp(v.title, v.x, v.y, v.w, 'center')
				lg.rectangle('line',v.x,v.y,v.w,v.h)
		end
		
		-- LOAD CUSTOM
		if --playerControl.menu.edit and
			mx > m.x and mx < m.x + m.w and
			my > playerControl.menu.button.loadCustom.y and
			my < playerControl.menu.y + playerControl.menu.h	then 
				lg.setColor(255,100,0)
		end				
		m.writeTitle(b.loadCustom)
		for i, v in ipairs(b.loadCustom) do
			if mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				if #m.custom[i]>0 then 
					lg.setColor(0,100,0)
				else
					lg.setColor(0,0,0)
				end
				lg.rectangle('fill',v.x,v.y,v.w,v.h)
				--lgp(v.title, v.x, v.y, v.w, 'center')
			else
			
			end
				lg.setColor(255,255,255)
				lgp(v.title, v.x, v.y, v.w, 'center')
				lg.rectangle('line',v.x,v.y,v.w,v.h)
		end
		
	end
	
end

function playerControl.setKeyBind(d)
	local k = playerControl.key
	for i=1,#k do
		if i<= #d then 
			k[i].bind = d[i]
		end
	end
end

function playerControl.draw()
	
	playerControl.menu.draw()
end

function playerControl.keypressed(key, scancode, isrepeat)
	
	-- check which keys are held down.
	local k = playerControl.key
	for i = 1,#k do
		if key == k[i].bind then
			k[i].isDown = true
		end
	end

	-- edit and update keys from playerControl.menu
	if playerControl.menu.edit then
		
		local mx,my = love.mouse.getPosition()		
		local b = playerControl.menu.button
		
		for i, v in ipairs(b.keyBind) do
			if mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				playerControl.key[i].bind = key
				playerControl.updateKeys()
			end
		end
	end


	
	

	
end

function playerControl.keyreleased(key, scancode, isrepeat)
	local k = playerControl.key
	for i = 1,#k do
		if key == k[i].bind then
			k[i].isDown = false
		end
	end
end

function playerControl.mousepressed(mx, my, button, istouch)
	local m = playerControl.menu
	

	if mx > m.x and mx < m.x + m.w and my > m.y and my < m.button.default.y then
		if m.edit == false then m.edit = true
		elseif m.edit == true then m.edit =  false 
		end
	end
	--=======================================


		local b = playerControl.menu.button
		local c = playerControl.menu.custom
		local k = playerControl.key
		

		for i, v in ipairs(b.default) do
			if mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				--love.graphics.setBackgroundColor(100,100*(i-1),100)
				playerControl.setKeyBind(playerControl.menu.default[i])
			end			
					
		end
		
		for i, v in ipairs(b.saveCustom) do
			if mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				for j = 1,#k do
					c[i][j] = k[j].bind
				end	
			end			
			
		end
		
		for i, v in ipairs(b.loadCustom) do
			if #c[i] > 0 and
				mx > v.x and mx < v.x + v.w and my > v.y and my < v.y + v.h then
				for j = 1,#c[i] do
					k[j].bind = c[i][j]
					playerControl.updateKeys()
				end
			end			
		end	

end

return playerControl