local mouse = {
	timer = 0,
	trail={{x=0,y=0,r=0}},
	pulseInterval = 0.01,
	pulseTime = 1,
	pulseRadius = 40,
}

local m = mouse
local lg = love.graphics

function m.load()

end

function m.update(dt)
	mouse.timer = mouse.timer + dt
	if m.timer > m.pulseInterval then 
		m.timer = 0
		local x,y = love.mouse.getPosition()
		m.trail[#m.trail+1]={x=x,y=y,r=0}
	end
	
	local dr = m.pulseRadius/m.pulseTime
	local mx,my = love.mouse.getPosition()
	for i=#m.trail,1,-1 do
		local p = m.trail[i]
		if p.r > m.pulseRadius then 
			table.remove(m.trail,i)
		else
			p.r = p.r + dr*dt
			--p.x = p.x + (mx-p.x)*dt
			--p.y = p.y + (my-p.y)*dt

			
		end
	end
	
	
end

function m.draw()
	local pi = math.pi
	for i=1,#m.trail do
		local p = m.trail[i]
		lg.setColor(255,255,0, 200 * (m.pulseRadius-p.r)/m.pulseRadius)
		lg.circle('fill',p.x,p.y,p.r,4)
		
		local x,y = love.mouse.getPosition()
		lg.polygon('fill',x,y,
			x + p.r * math.cos(0),
			y + p.r * math.sin(0),			
			x + p.r * math.cos(pi),
			y + p.r * math.sin(pi)
			)
	end
	
	--lg.setColor(0,0,0)
	local x,y = love.mouse.getPosition()
	lg.polygon('line',x,y,
		x + 30 * math.cos(0),
		y + 30 * math.sin(0),			
		x + 30 * math.cos(pi),
		y + 30 * math.sin(pi)
		)	
end

return mouse

